/*
	This code is from the VOXELIZING TUTORIAL by timetravelbeard
		learn more at the links below:
			https://www.patreon.com/timetravelbeard
			https://youtube.com/@timetravelbeard3588
			https://discord.gg/S6F4r6K5yU 
			
		if you use this code as is, please leave this header. feel free to use this code in any shaders.
*/
	
	//positions
	vec3 shadow_view_pos = vec4(gl_ModelViewMatrix * gl_Vertex).xyz;
	vec3 foot_pos = (shadowModelViewInverse * vec4( shadow_view_pos ,1.) ).xyz;
	vec3 world_pos = foot_pos + cameraPosition;


	//voxel map position
	

	vec3 block_centered_relative_pos = foot_pos + at_midBlock.xyz/64.0 +fract(cameraPosition);
	ivec3 voxel_pos = ivec3(block_centered_relative_pos + VOXEL_RADIUS);


	//write voxel data
	if(mod(gl_VertexID,4)==0  //only write for 1 vertex
		&& clamp(voxel_pos,0,VOXEL_AREA) == voxel_pos //and in voxel range
	) //for one vertex per face, write if in range
	{
		//pick data to send
		#define VISUALIZED_DATA 3 //[0 1 2 3 4]
		#if VISUALIZED_DATA == 0
			//visualize color average
			vec4 voxel_data =	vec4(textureLod(gtexture, texcoord,log2(float(textureSize(gtexture, 0).x))).rgb* glcolor.rgb,1.);
		#endif
		#if VISUALIZED_DATA == 1
			//visualize position
			vec4 voxel_data = vec4(fract((block_centered_relative_pos.xyz+floor(cameraPosition))*.05),1.);
		#endif
		#if VISUALIZED_DATA == 2
			//visualize color of one pixel
			vec4 voxel_data =	vec4(textureLod(gtexture, texcoord,0).rgb* glcolor.rgb,1.);
		#endif
		#if VISUALIZED_DATA == 3
			//light value
			vec4 light_color =  vec4(textureLod(gtexture, texcoord,log2(float(textureSize(gtexture, 0).x))).rgb* glcolor.rgb,1.);
			light_color.rgb=light_color.rgb/max(light_color.r,max(light_color.g,light_color.b));
			#if FLICKERING_TORCHES == 1
				light_color =(mc_Entity.x == 10030.0) ? mix(vec4(TORCH_LOW_R,TORCH_LOW_G,TORCH_LOW_B,1.),
				vec4(TORCH_HI_R,TORCH_HI_G,TORCH_HI_B,1.),
				(.7+.2*sin(frameTimeCounter*1.+world_pos.x)+.2*sin(frameTimeCounter*2.+world_pos.z)+.1*sin(frameTimeCounter*5.+world_pos.y))) : light_color;
			#endif
			vec4 voxel_data =	vec4(at_midBlock.w/15.)*light_color;
		#endif
		#if VISUALIZED_DATA == 4
			//certain block by id
			vec4 voxel_data =	mc_Entity.x == 10000.? vec4(0.,1.,0.,1.) : mc_Entity.x == 10001.? vec4(0.5,0.5,0.,1.) : vec4(0.2);
		#endif
		
		//visialize player position
		//if(frameTimeCounter < 1. && distance(vec3(voxel_pos),vec3(VOXEL_RADIUS))< 3.)
		{
		//	voxel_data = vec4(0.,0.,1.,1.);
		}
		
		//pack data
		uint integerValue = packUnorm4x8( voxel_data );
		
		//write to 3d image	 
		//          //imageStore(  //imageAtomicMax(   are some options for writing, look up on khronos.org (opengl documentation)
		imageAtomicMax( cimage1, voxel_pos, integerValue );	
			
		
		
	}